from SystemEntity import SystemEntity
import logging
logger = logging.getLogger(__name__)

class Node(SystemEntity):
    def __init__(self,id,network):
        SystemEntity.__init__(self,network)
        self.id = id
        self.adjacentNodes = []
        self.messageQueue = []
        self.commands={"sendMessage":self.sendMessage,
                       }



    def enqueMessge(self,message):
        '''

        :param message: (timestamp , payload)    --- timestamp is the tick value at which node has inserted this message in queue
        payload #1 : ('NOde1', 'Node2', 'Content of message')
        payload #2 :

        :return:
        '''
        self.messageQueue.append(message)
        print("message enqued")

    def dequeMessge(self):
        return self.messageQueue.pop(0)



    def sendMessage(self,time,params):
        '''

        :param params: ('1','2','hello2')
        :return:
        '''
        link = self.network.links.get((params[0],params[1]))
        link.enqueMessge((time,params))
        logger.info("Sending Message : " + str((time,params)))
        pass

    def processMessage(self,time,payload):
        print("fianlly reachec : " + str(payload))

    def simulate(self,time):
        # logger.info("simulating .. ")
        '''
        Process message first then process task in todo list
        Here it is just intuition , i don`t what should be processing sequence
        
        all messages will be proceessed i.e., at the end of each tick simulation links will not have 
        any unprocessed message the receive buffer or message-queue 

        '''
        # todo process messages in queue
        # generate tasks for todolist based on messges
        for message in self.messageQueue:
            self.processMessage(message[0],message[1]) # message : (time,(payload))


        # TODO : perform task from todolist which are relevant for current tick

        try:
            tasks = self.todoList.pop(time)
            for task in tasks:
                command = self.commands.get(task[0])
                command(time,task[1:])
        except KeyError as ke:
            # not task pending at this time
            pass

        pass

if __name__ == '__main__':
    # node = Node('1')
    # cmd = node.commands.get("sendMessage")
    # cmd("1 ","2 "," : Hello world")

    from collections import defaultdict

    # when accessing a key, if it has no value - create a list by default
    d = defaultdict(list)
    d["key"].append("a value")
    d["key"].append("another value")
    print(d)
    x = d.pop("key2")
    print(x)
    print(d.get("key2"))




